#ifndef EXCEPTIONS_H_
#define EXCEPTIONS_H_

class OutOfMemory
{
};

class GeneralException : public std::exception
{
	std::string m_msg;
  public:
	GeneralException(const std::string& msg)
		: m_msg(msg)
	{}

	virtual const char* what() const {return m_msg.c_str();}
};

class ParseException : public std::exception
{
	int m_line;
	std::string m_msg;

public:
	ParseException(int line, const std::string& msg)
		: m_msg(msg)
		, m_line(line)
	{};

	virtual const char* what() const {return m_msg.c_str();}
	int GetLine() const {return m_line;}
};

#endif
