#ifndef FILEFETCHERLOADWORKER_H_
#define FILEFETCHERLOADWORKER_H_

#include "FileFetcher.h"
#include "ThreadPrimitives.h"

#include <BoundedQueue.h>

class FileFetcherLoadWorker
{
	FileFetcher& m_fetcher;

	Thread* m_workThread;

	void Run();
	void DoFileLoad(FileFetcher::WorkUnit* fileLoad); // Loads the file, synchronously

public:
	FileFetcherLoadWorker(FileFetcher& fetcher);
	virtual ~FileFetcherLoadWorker();
};

#endif
